const std = @import("std");
const SDL = @import("sdl2");

const MenuSelection = @import("MenuSelection.zig");
const MenuTab = @import("MenuTab.zig");

const Self = @This();

tab_list: [2]MenuTab = [2]MenuTab{
    MenuTab.init("1P", &.{
        MenuSelection.init("Play", play),
        MenuSelection.init("Print", print),
    }),
    MenuTab.init("Options", &.{
        MenuSelection.init("Play", play),
        MenuSelection.init("Print", print),
    }),
},

tab: usize = 0,
selection: usize = 0,

holding_down: bool = false,

pub fn init() Self {
    return Self{};
}

pub fn tick(self: *Self) void {
    var key_state = SDL.SDL_GetKeyboardState(null);
    if (key_state[SDL.SDL_SCANCODE_DOWN] == 1 and !self.holding_down) {
        self.holding_down = true;
        self.actionSelDown();
    }
    if (key_state[SDL.SDL_SCANCODE_DOWN] == 0) {
        self.holding_down = false;
    }
    std.debug.print(
        \\Tab: {s}
        \\Selection: {s}
        \\
            , .{ self.tab_list[self.tab].name, self.tab_list[self.tab].contents[self.selection].name });
}

fn actionSelDown(self: *Self) void {
    self.selection += 1;
    self.selection %= self.tab_list[self.tab].contents.len;
}

fn play(self: *Self) void {
    _ = self;
    std.debug.print("Play", .{});
}

fn print(self: *Self) void {
    _ = self;
    std.debug.print("Print", .{});
}
